#ifndef CONFIG_STD
#define CONFIG_STD

//
//  AlgAE Configuration file
//    
//  Currently recognizes  g++, version 2.7.2 for Unix and 2.8.0 for GnuWin32
//  MS Visual C++, version 5.0
//

//
//  Default names for various include files.
//
#define ARPANET_INCL <arpa/inet.h>
#define ASSERT_INCL <assert.h>
#define CPPSTRING_INCL <string>
#define CSTRING_INCL <string.h>
#define FSTREAM_INCL <fstream.h>
#define IOMANIP_INCL <iomanip.h>
#define IOSTREAM_INCL <iostream.h>
#define IPDATA_INCL <netinet/in.h>
#define OPENCLOSE_INCL <unistd.h>
#define NETHOST_INCL <netdb.h>
#define SOCKET_INCL <sys/socket.h>
#define STDIO_INCL <stdio.h>
#define STDLIB_INCL <stdlib.h>
#define STRSTREAM_INCL <strstrea.h>


//
// The following includes are not required to compile the AlgAE client
// code, but are used in some of the algorithm demos.
//
#define ALGO_INCL <algo.h>
#define MEM_INCL <mem.h>
#define STACK_INCL <stack.h>
#define VECTOR_INCL <vector.h>


// Define this if the compiler supports the placement new syntax.
#define PLACEMENT_NEW

// Define this if the compiler does not support reassignment of iostream
// buffers via the function  rdbuf(streambuf&)
#undefine __bad_rdbuf__

// Some compilers call this string function "erase", others "remove"
#define STRERASE erase


#ifdef __GNUG__
  /* Compiler is gcc/g++ */

#ifdef __CYGWIN32__
  /* This is the GnuWin32 port for Windows 95/NT

  /* Compiler is gcc/g++ */

#else
  /* This is some other port of g++, probably a Unix system.
#endif

#elsif defined(_MSC_VER)

/* compiler is Microsoft Visual C++ */

#define MEMDC
#define __bad_rdbuf__

#undefine ALGO_INCL
#define ALGO_INCL <utils/algo.h>

#undefine ARPANET_INCL
#define ARPANET_INCL <winsock2.h>

#undefine CPPSTRING_INCL
#define CPPSTRING_INCL <utils/string.h>

#undefine CSTRING_INCL
#define CSTRING_INCL <string.h>

#undefine IPDATA_INCL
#define IPDATA_INCL <winsock2.h>

#undefine OPENCLOSE_INCL
#define OPENCLOSE_INCL <io.h>

#undefine NETHOST_INCL
#define NETHOST_INCL <winsock2.h>

#undefine SOCKET_INCL
#define SOCKET_INCL <winsock2.h>

#undefine STDIO_INCL
#define STDIO_INCL <stdio.h>

#undefine STDLIB_INCL
#define STDLIB_INCL <stdlib.h>

#undefine STRSTREAM_INCL
#define STRSTREAM_INCL <strstrea.h>



#undefine ALGO_INCL
#define ALGO_INCL <utils/algo.h>

#undefine MEM_INCL
#define MEM_INCL <alloc.h>

#undefine STACK_INCL
#define STACK_INCL <utils/stack.h>

#undefine VECTOR_INCL
#define VECTOR_INCL <utils/vector.h>


#else

#pragma warning "Possible configuration error: Compiler is not recognized."

#endif


#endif

