#ifndef VISIBLE_INTEGER_H
#define VISIBLE_INTEGER_H

#include <algae/config.h>
#include <algae/algae.h>
#include <algae/visible.h>
#include <utils/indexable.h>
#include <iostream>
#include <string>



class VisibleInteger: public Visible
{
public:
   VisibleInteger(AlgAE::Color c = AlgAE::Magenta);
   VisibleInteger(int i, AlgAE::Color c = AlgAE::Magenta);
   VisibleInteger(int i, const std::string& name, AlgAE::Color c = AlgAE::Magenta);
   VisibleInteger(int i, const char* name, AlgAE::Color c = AlgAE::Magenta);
   VisibleInteger (const VisibleInteger& x);

   void operator= (const VisibleInteger& x);
   void operator= (const int x);

   ~VisibleInteger();

   operator int() const;

   // Use this operation to have a pointer arrow to an element of an
   // array-like structure
   void indexes (const Indexable* arrayLike);
   void indexes (const Indexable& arrayLike);
  

   // Required for animation
   virtual void touchAllPointers() const;
   virtual void writeText(std::ostream& out) const;

  VisibleInteger& operator++ ()  {++_data; return *this;}
  VisibleInteger operator++ (int);

  VisibleInteger& operator-- ()  {--_data; return *this;}
  VisibleInteger operator-- (int);
private:
   int _data;
   AlgAE::Color _color;
   const Indexable* indexed;
};


inline void VisibleInteger::indexes (const Indexable& arrayLike)
{
  indexes (&arrayLike);
}


#endif
