#ifndef VISIBLE_STRING_H
#define VISIBLE_STRING_H

#include <algae/config.h>
#include <algae/algae.h>
#include <algae/visible.h>
#include <iostream>
#include <string>



class VisibleString: public Visible
{
public:
   VisibleString(AlgAE::Color c = AlgAE::Magenta);
   VisibleString(const std::string& s, AlgAE::Color c = AlgAE::Magenta);
   VisibleString(const std::string& s, const std::string& name,
		 AlgAE::Color c = AlgAE::Magenta);
   VisibleString (const VisibleString& x);

   void operator= (const VisibleString& x);
   void operator= (const std::string& x);

   ~VisibleString();

   operator std::string() const;

   std::string& str()             {return _data;}
   const std::string& str() const {return _data;}

   // Required for animation
   virtual void touchAllPointers() const;
   virtual void writeText(std::ostream& out) const;

private:
   std::string _data;
   AlgAE::Color _color;
};




#endif
