#include <algae/config.h>
#include <string>

#include <algae/algae.h>
#include <algae/astream.h>
#include <algae/messages.h>

#include <string.h>

using namespace std;

AlgAEostream AlgAEstdioStreams::aout;
AlgAEistream AlgAEstdioStreams::ain;

AlgAEStreamBuffer::AlgAEStreamBuffer (int bufferSize, bool forInput)
  : streambuf(), buffer(new char[bufferSize+1]), bufSize(bufferSize)
{
  if (forInput)
    {
         setg(buffer, buffer+bufferSize, buffer+bufferSize);
	 setp(0, 0);
    }
  else
    {
      setp (buffer, buffer+bufferSize);
      setg (0,0,0);
    }
}

AlgAEStreamBuffer::~AlgAEStreamBuffer ()
{
  sync();
  delete [] buffer;
}



int AlgAEStreamBuffer::sync()
{
  overflow(EOF);
  return 0;
}

int AlgAEStreamBuffer::overflow (int ch)
{
  if (pbase() != pptr())
    {
      *(pptr()) = 0;
      setp (pbase(), epptr());
      algae->msgs->stdOutput(pbase());
    }
  if (ch != EOF)
    sputc(ch);
 return 0;
}


int AlgAEStreamBuffer::underflow ()
{
  string buf = algae->msgs->stdInput();
  string::size_type len = buf.size();
  if (len > bufSize)
    len = bufSize;
  strncpy (buffer, buf.c_str(), len);
  setg (buffer, buffer, buffer+len);
  return *(buffer);
}



AlgAEostream::AlgAEostream ()
  : ostream(new AlgAEStreamBuffer(80,false)) {}

AlgAEostream::~AlgAEostream () {delete rdbuf();}


AlgAEistream::AlgAEistream ()
  : istream(new AlgAEStreamBuffer(80,true)) {}

AlgAEistream::~AlgAEistream () {delete rdbuf();}


