#include <algae/config.h>
#include <algae/sockstr.h>
#include <cstdio>

#ifdef USE_WINSOCK
#include <winsock2.h>
#else
#include <netinet/in.h>
#include <sys/socket.h>
#endif

using namespace std;

SocketBuffer::SocketBuffer (int socketDescriptor,
			    int bufferSize,
			    bool forInput)
: streambuf(), bufSize(bufferSize),
  buffer(new char[bufferSize+1]),
  socketd(socketDescriptor)
{
  if (forInput)
    {
         setg(buffer, buffer+bufferSize, buffer+bufferSize);
	 setp(0, 0);
    }
  else
    {
      setp (buffer, buffer+bufferSize);
      setg (0,0,0);
    }
}

SocketBuffer::~SocketBuffer ()
{
  sync();
  delete [] buffer;
}



int SocketBuffer::sync()
{
  overflow(EOF);
  return 0;
}

int SocketBuffer::overflow (int ch)
{
  if (pbase() != pptr())
    {
      *(pptr()) = 0;
      //      cerr << "Sending: " << pbase() << endl;
      send (socketd, pbase(), pptr()-pbase(), 0);
      setp (pbase(), epptr());
    }
  if (ch != EOF)
    sputc(ch);
 return 0;
}


int SocketBuffer::underflow ()
{
  int nrecv = recv (socketd, buffer, bufSize, 0);
  if (nrecv <= 0)
    {
      nrecv = 1;
      *buffer = -1;
    }
  *(buffer+nrecv) = 0;
  //      cerr << "Received: " << buffer << endl;
  setg (buffer, buffer, buffer+nrecv);
  return *(buffer);
}



oSocketStream::oSocketStream (int socketDescriptor)
  : ostream(new SocketBuffer(socketDescriptor, 64, false)) {}

oSocketStream::~oSocketStream () {delete rdbuf();}


iSocketStream::iSocketStream (int socketDescriptor)
  : istream(new SocketBuffer(socketDescriptor, 64, true)) {}

iSocketStream::~iSocketStream () {delete rdbuf();}


