package edu.odu.cs.zeil.AlgAE.Client.SourceViewer;

public class SourceLocation {

	public Class<?> methodContainer;
	public String fileName;
	public int lineNumber;
	
	public SourceLocation (Class<?> container, String filename, int line) {
		methodContainer = container;
		fileName = filename;
		lineNumber = line;
	}
	
	public String getResourceName()
	{
		return methodContainer.getPackage().getName() + "." + fileName;
	}
	
	public String toString() {
		return getResourceName() + ":" + lineNumber;
	}
	
	public boolean equals (Object obj) {
		SourceLocation other = (SourceLocation)obj;
		if (other == null)
			return false;
		else if (lineNumber != other.lineNumber)
			return false;
		else if (methodContainer != other.methodContainer)
			return false;
		else if (fileName == null || other.fileName == null)
			return false;
		else return fileName.equals(other.fileName);
	}

	public String getFileName() {
		return fileName;
	}

	public Class<?> getContainer() {
		return methodContainer;
	}
}
